
/*  d4ref.c   (c)Copyright Sequiter Software Inc., 1987-1990.  All rights reserved.

    Returns the reference base number corresponding to the name of a previously
    opened database.

    Return
	>=0    Database Reference Number
	 -1    Database has not been opened
*/

#include "p4misc.h"
#include "d4all.h"

#include <string.h>

extern   BASE  *v4base ;
extern   int    v4last_base ;


d4ref( char *dbf_name )
{
   int   base_on, len ;
   char  name[90] ;

   u4name_full( name, dbf_name, ".DBF" ) ;

   len = 0 ;
   while ( name[len]  !=  ' '  &&  name[len] != '\000' )  len++ ;
   if (len > 63) len = 63 ;

   name[len] = '\000' ;
   u4upper( name ) ;

   base_on =  v4last_base ;
   while ( base_on >= 0)
   {
      if ( memcmp( name, v4base[base_on].name, (size_t) len) == 0)
      {
	 if (v4base[base_on].name[len] == ' ' || v4base[base_on].name[len] == '\000')
	    return( base_on) ;
      }
      base_on =  v4base[base_on].prev ;
   }

   return( -1) ;
}

