
/*  d4seek.c   (c)Copyright Sequiter Software Inc., 1987-1990.  All rights reserved.

    Locates and reads the record.

    Returns

       0 Success
       1 Inexact Find
       2 On record after
       3 EOF
      -1 Error
*/

#include "d4all.h"
#include "u4error.h"

extern  INDEX *v4index ;

int  d4seek( void *search_string )
{
   int    index_ref ;

   if ( (index_ref = i4seek_ref()) < 0 )
   {
      u4error( E_NO_INDEX, d4name(), (char *) 0 ) ;
      return( -1 ) ;
   }

   #ifdef CLIPPER
      if ( v4index[index_ref].i_type == 'N' ||  v4index[index_ref].i_type == 'F' ) 
      {
	 char  seek_buf[32] ;
	 c4dtok( index_ref, *((double *)search_string), seek_buf ) ;
	 return( d4seek_key( index_ref, seek_buf) ) ;
      }
      else
	 return( d4seek_key( index_ref, search_string )) ;
   #else
      return( d4seek_key( index_ref, (char *) search_string) ) ;
   #endif
}


