
/* (c)Copyright Sequiter Software Inc., 1987-1990.  All rights reserved.

   f4ref.c
*/

#include "d4all.h"
#include "u4error.h"
#include "p4misc.h"

#include <string.h>

extern  BASE  *v4base ;
extern  int    v4cur_base ;

/*  f4ref

    returns
       Normal:  The field reference number corresponding to the field name.
       Error:   -1;  The field name was not located.
*/

long  f4ref( char *field_name )
{
   int    field_on, len ;
   FIELD *field_ptr ;
   BASE  *base_ptr  ;
   char   name[11]  ;

   if ( v4cur_base < 0 )
   {
      u4error( E_D_MISSING, "When Calling 'f4ref()'", (char *) 0 ) ;
      return( -1L ) ;
   }

   base_ptr =  v4base +  v4cur_base ;

   memcpy( name, field_name, 11) ;
   name[10] = '\000' ;
   u4upper( name )  ;

   len = 0 ;
   while ( name[len] != ' '  &&  name[len] != '\000'  && len < 10)
	   len ++ ;

   if ( len == 0)  
   {
      u4error( E_FIELD, (char *) 0 ) ;
      return( -1) ;
   }

   field_ptr =  base_ptr->fields ;

   for ( field_on=0;  field_on< base_ptr->num_fields; field_on++)
   {
      if ( memcmp( name, field_ptr->name, (size_t) len) == 0)
      {
	 if ( field_ptr->name[len] == ' ' || field_ptr->name[len] == '\000' ||  len == 10)
	      return( ((long)field_on) | (((long)v4cur_base)<<16) ) ;
      }
      field_ptr++ ;
   }

   u4error( E_FIELD, field_name, (char *) 0 ) ;

   return( -1 ) ;
}

/*  f4j_ref 

    Returns

       Normal:  The field reference number corresponding to the j'th field.
       Error:   -1;  Bad Parameter
*/

long  f4j_ref( int j_ref )
{
   if ( j_ref >  f4num_fields() ||  j_ref < 1  )  
      return( -1L ) ;
   else
      return( (((long) v4cur_base) << 16)  |   (long) (j_ref-1) ) ;
}

